import Foundation

enum Children: String, Codable {
  case son
}

struct Parent: Codable {
  let children: Children?

  init(children: Children?) {
    self.children = children
  }

  public enum CodingKeys: String, CodingKey {
    case children
  }

//  public init(from decoder: Decoder) throws {
//    let container = try decoder.container(keyedBy: CodingKeys.self)
//    let children = try? container.decode(Children.self, forKey: .children)
//    self.init(children: children)
//  }
}

let rawData = """
{
  "children": "daughter"
}
""".data(using: .utf8)!

try JSONDecoder().decode(Parent.self, from: rawData)
